Index: /trunk/classes/DelphesClasses.cc
===================================================================
--- /trunk/classes/DelphesClasses.cc	(revision 1379)
+++ /trunk/classes/DelphesClasses.cc	(revision 1380)
@@ -112,5 +112,4 @@
   Position(0.0, 0.0, 0.0, 0.0),
   Dxy(0),SDxy(0),Xd(0),Yd(0),Zd(0),
-  Tau1(0.0), Tau2(0.0), Tau3(0.0), Tau4(0.0), Tau5(0.0),
   Area(0.0, 0.0, 0.0, 0.0),
   NCharged(0),
@@ -132,4 +131,9 @@
   FracPt[3] = 0.0;
   FracPt[4] = 0.0;
+  Tau[0] = 0.0;
+  Tau[1] = 0.0;
+  Tau[2] = 0.0;
+  Tau[3] = 0.0;
+  Tau[4] = 0.0;
 }
 
@@ -236,9 +240,9 @@
   object.FracPt[3] = FracPt[3];
   object.FracPt[4] = FracPt[4];
-  object.Tau1 = Tau1;
-  object.Tau2 = Tau2;
-  object.Tau3 = Tau3;
-  object.Tau4 = Tau4;
-  object.Tau5 = Tau5;
+  object.Tau[0] = Tau[0];
+  object.Tau[1] = Tau[1];
+  object.Tau[2] = Tau[2];
+  object.Tau[3] = Tau[3];
+  object.Tau[4] = Tau[4];
 
   object.fFactory = fFactory;
@@ -298,9 +302,9 @@
   FracPt[3] = 0.0;
   FracPt[4] = 0.0;
-  Tau1 = 0.0;
-  Tau2 = 0.0;
-  Tau3 = 0.0;
-  Tau4 = 0.0;
-  Tau5 = 0.0;
+  Tau[0] = 0.0;
+  Tau[1] = 0.0;
+  Tau[2] = 0.0;
+  Tau[3] = 0.0;
+  Tau[4] = 0.0;
 
   fArray = 0;
Index: /trunk/classes/DelphesClasses.h
===================================================================
--- /trunk/classes/DelphesClasses.h	(revision 1379)
+++ /trunk/classes/DelphesClasses.h	(revision 1380)
@@ -299,5 +299,164 @@
   Float_t EhadOverEem; // ratio of the hadronic versus electromagnetic energy deposited in the calorimeter
 
-  // -- PileUpJetID variables ---
+  Int_t    NCharged; // number of charged constituents 
+  Int_t    NNeutrals; // number of neutral constituents 
+  Float_t  Beta; // (sum pt of charged pile-up constituents)/(sum pt of charged constituents) 
+  Float_t  BetaStar; // (sum pt of charged constituents coming from hard interaction)/(sum pt of charged constituents) 
+  Float_t  MeanSqDeltaR; // average distance (squared) between constituent and jet weighted by pt (squared) of constituent
+  Float_t  PTD; // average pt between constituent and jet weighted by pt of constituent
+  Float_t  FracPt[5]; // (sum pt of constituents within a ring 0.1*i < DeltaR < 0.1*(i+1))/(sum pt of constituents) 
+
+  Float_t Tau1; // 1-subjettiness
+  Float_t Tau2; // 2-subjettiness
+  Float_t Tau3; // 3-subjettiness
+  Float_t Tau4; // 4-subjettiness
+  Float_t Tau5; // 5-subjettiness
+
+  TRefArray Constituents; // references to constituents
+  TRefArray Particles; // references to generated particles
+
+  static CompBase *fgCompare; //!
+  const CompBase *GetCompare() const { return fgCompare; }
+
+  TLorentzVector P4();
+
+  ClassDef(Jet, 2)
+};
+
+//---------------------------------------------------------------------------
+
+class Track: public SortableObject
+{
+public:
+  Int_t PID; // HEP ID number
+
+  Int_t Charge; // track charge
+
+  Float_t PT; // track transverse momentum
+
+  Float_t Eta; // track pseudorapidity
+  Float_t Phi; // track azimuthal angle
+
+  Float_t EtaOuter; // track pseudorapidity at the tracker edge
+  Float_t PhiOuter; // track azimuthal angle at the tracker edge
+
+  Float_t X; // track vertex position (x component)
+  Float_t Y; // track vertex position (y component)
+  Float_t Z; // track vertex position (z component)
+  Float_t T; // track vertex position (z component)
+
+  Float_t XOuter; // track position (x component) at the tracker edge
+  Float_t YOuter; // track position (y component) at the tracker edge
+  Float_t ZOuter; // track position (z component) at the tracker edge
+  Float_t TOuter; // track position (z component) at the tracker edge
+
+  Float_t Dxy;     // track signed transverse impact parameter
+  Float_t SDxy;    // signed error on the track signed transverse impact parameter
+  Float_t Xd;      // X coordinate of point of closest approach to vertex
+  Float_t Yd;      // Y coordinate of point of closest approach to vertex
+  Float_t Zd;      // Z coordinate of point of closest approach to vertex
+
+  TRef Particle; // reference to generated particle
+
+  static CompBase *fgCompare; //!
+  const CompBase *GetCompare() const { return fgCompare; }
+
+  TLorentzVector P4();
+
+  ClassDef(Track, 2)
+};
+
+//---------------------------------------------------------------------------
+
+class Tower: public SortableObject
+{
+public:
+  Float_t ET; // calorimeter tower transverse energy
+  Float_t Eta; // calorimeter tower pseudorapidity
+  Float_t Phi; // calorimeter tower azimuthal angle
+
+  Float_t E; // calorimeter tower energy
+
+  Float_t T; //particle arrival time of flight
+
+  Float_t Eem; // calorimeter tower electromagnetic energy
+  Float_t Ehad; // calorimeter tower hadronic energy
+
+  Float_t Edges[4]; // calorimeter tower edges
+
+  TRefArray Particles; // references to generated particles
+
+  static CompBase *fgCompare; //!
+  const CompBase *GetCompare() const { return fgCompare; }
+
+  TLorentzVector P4();
+
+  ClassDef(Tower, 1)
+};
+
+//---------------------------------------------------------------------------
+
+class HectorHit: public SortableObject
+{
+public:
+  Float_t E; // reconstructed energy [GeV]
+
+  Float_t Tx; // angle of the momentum in the horizontal (x,z) plane [urad]
+  Float_t Ty; // angle of the momentum in the verical (y,z) plane [urad]
+
+  Float_t T; // time of flight to the detector [s]
+
+  Float_t X; // horizontal distance to the beam [um]
+  Float_t Y; // vertical distance to the beam [um]
+  Float_t S; // distance to the interaction point [m]
+
+  TRef Particle; // reference to generated particle
+
+  static CompBase *fgCompare; //!
+  const CompBase *GetCompare() const { return fgCompare; }
+
+  ClassDef(HectorHit, 1)
+};
+
+//---------------------------------------------------------------------------
+
+class Candidate: public SortableObject
+{
+  friend class DelphesFactory;
+
+public:
+  Candidate();
+
+  Int_t PID;
+
+  Int_t Status;
+  Int_t M1, M2, D1, D2;
+
+  Int_t Charge;
+
+  Float_t Mass;
+
+  Int_t IsPU;
+  Int_t IsConstituent;
+
+  UInt_t BTag;
+  UInt_t TauTag;
+
+  Float_t Eem;
+  Float_t Ehad;
+
+  Float_t Edges[4];
+  Float_t DeltaEta;
+  Float_t DeltaPhi;
+
+  TLorentzVector Momentum, Position, Area;
+
+  Float_t  Dxy;
+  Float_t  SDxy;
+  Float_t  Xd;
+  Float_t  Yd;
+  Float_t  Zd;
+
+  // PileUpJetID variables
 
   Int_t    NCharged;
@@ -309,168 +468,5 @@
   Float_t  FracPt[5];
 
- // -- Nsubjettiness variables ---
-
-  Float_t Tau1;
-  Float_t Tau2;
-  Float_t Tau3;
-  Float_t Tau4;
-  Float_t Tau5;
-
-  TRefArray Constituents; // references to constituents
-  TRefArray Particles; // references to generated particles
-
-  static CompBase *fgCompare; //!
-  const CompBase *GetCompare() const { return fgCompare; }
-
-  TLorentzVector P4();
-
-  ClassDef(Jet, 2)
-};
-
-//---------------------------------------------------------------------------
-
-class Track: public SortableObject
-{
-public:
-  Int_t PID; // HEP ID number
-
-  Int_t Charge; // track charge
-
-  Float_t PT; // track transverse momentum
-
-  Float_t Eta; // track pseudorapidity
-  Float_t Phi; // track azimuthal angle
-
-  Float_t EtaOuter; // track pseudorapidity at the tracker edge
-  Float_t PhiOuter; // track azimuthal angle at the tracker edge
-
-  Float_t X; // track vertex position (x component)
-  Float_t Y; // track vertex position (y component)
-  Float_t Z; // track vertex position (z component)
-  Float_t T; // track vertex position (z component)
-
-  Float_t XOuter; // track position (x component) at the tracker edge
-  Float_t YOuter; // track position (y component) at the tracker edge
-  Float_t ZOuter; // track position (z component) at the tracker edge
-  Float_t TOuter; // track position (z component) at the tracker edge
-
-  Float_t Dxy;     // track signed transverse impact parameter
-  Float_t SDxy;    // signed error on the track signed transverse impact parameter
-  Float_t Xd;      // X coordinate of point of closest approach to vertex
-  Float_t Yd;      // Y coordinate of point of closest approach to vertex
-  Float_t Zd;      // Z coordinate of point of closest approach to vertex
-
-  TRef Particle; // reference to generated particle
-
-  static CompBase *fgCompare; //!
-  const CompBase *GetCompare() const { return fgCompare; }
-
-  TLorentzVector P4();
-
-  ClassDef(Track, 2)
-};
-
-//---------------------------------------------------------------------------
-
-class Tower: public SortableObject
-{
-public:
-  Float_t ET; // calorimeter tower transverse energy
-  Float_t Eta; // calorimeter tower pseudorapidity
-  Float_t Phi; // calorimeter tower azimuthal angle
-
-  Float_t E; // calorimeter tower energy
-
-  Float_t T; //particle arrival time of flight
-
-  Float_t Eem; // calorimeter tower electromagnetic energy
-  Float_t Ehad; // calorimeter tower hadronic energy
-
-  Float_t Edges[4]; // calorimeter tower edges
-
-  TRefArray Particles; // references to generated particles
-
-  static CompBase *fgCompare; //!
-  const CompBase *GetCompare() const { return fgCompare; }
-
-  TLorentzVector P4();
-
-  ClassDef(Tower, 1)
-};
-
-//---------------------------------------------------------------------------
-
-class HectorHit: public SortableObject
-{
-public:
-  Float_t E; // reconstructed energy [GeV]
-
-  Float_t Tx; // angle of the momentum in the horizontal (x,z) plane [urad]
-  Float_t Ty; // angle of the momentum in the verical (y,z) plane [urad]
-
-  Float_t T; // time of flight to the detector [s]
-
-  Float_t X; // horizontal distance to the beam [um]
-  Float_t Y; // vertical distance to the beam [um]
-  Float_t S; // distance to the interaction point [m]
-
-  TRef Particle; // reference to generated particle
-
-  static CompBase *fgCompare; //!
-  const CompBase *GetCompare() const { return fgCompare; }
-
-  ClassDef(HectorHit, 1)
-};
-
-//---------------------------------------------------------------------------
-
-class Candidate: public SortableObject
-{
-  friend class DelphesFactory;
-
-public:
-  Candidate();
-
-  Int_t PID;
-
-  Int_t Status;
-  Int_t M1, M2, D1, D2;
-
-  Int_t Charge;
-
-  Float_t Mass;
-
-  Int_t IsPU;
-  Int_t IsConstituent;
-
-  UInt_t BTag;
-  UInt_t TauTag;
-
-  Float_t Eem;
-  Float_t Ehad;
-
-  Float_t Edges[4];
-  Float_t DeltaEta;
-  Float_t DeltaPhi;
-
-  TLorentzVector Momentum, Position, Area;
-
-  Float_t  Dxy;
-  Float_t  SDxy;
-  Float_t  Xd;
-  Float_t  Yd;
-  Float_t  Zd;
-
-  // PileUpJetID variables
-
-  Int_t    NCharged;
-  Int_t    NNeutrals;
-  Float_t  Beta;
-  Float_t  BetaStar;
-  Float_t  MeanSqDeltaR;
-  Float_t  PTD;
-  Float_t  FracPt[5];
-
-  // -- Nsubjettiness variables ---
+  // N-subjettiness variables
 
   Float_t Tau[5];